/****************************************************************************
**
** Copyright (C) 2016 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of Qt for Python.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL3 included in the
** packaging of this file. Please review the following information to
** ensure the GNU Lesser General Public License version 3 requirements
** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 2.0 or (at your option) the GNU General
** Public license version 3 or any later version approved by the KDE Free
** Qt Foundation. The licenses are as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-2.0.html and
** https://www.gnu.org/licenses/gpl-3.0.html.
**
** $QT_END_LICENSE$
**
****************************************************************************/

//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QDebug>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <pysideqenum.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED

#include <typeinfo>
#include <iterator>

// module include
#include "pyside6_qtbluetooth_python.h"

// main header
#include "qbluetoothserviceinfo_wrapper.h"

// inner classes
#include "qbluetoothserviceinfo_alternative_wrapper.h"
#include "qbluetoothserviceinfo_sequence_wrapper.h"

// Extra includes
#include <QList>
#include <QtBluetooth/qbluetoothaddress.h>
#include <QtBluetooth/qbluetoothdeviceinfo.h>
#include <QtBluetooth/qbluetoothserviceinfo.h>
#include <QtBluetooth/qbluetoothuuid.h>


#include <cctype>
#include <cstring>



template <class T>
static const char *typeNameOf(const T &t)
{
    const char *typeName =  typeid(t).name();
    auto size = std::strlen(typeName);
#if defined(Q_CC_MSVC) // MSVC: "class QPaintDevice * __ptr64"
    if (auto lastStar = strchr(typeName, '*')) {
        // MSVC: "class QPaintDevice * __ptr64"
        while (*--lastStar == ' ') {
        }
        size = lastStar - typeName + 1;
    }
#else // g++, Clang: "QPaintDevice *" -> "P12QPaintDevice"
    if (size > 2 && typeName[0] == 'P' && std::isdigit(typeName[1])) {
        ++typeName;
        --size;
    }
#endif
    char *result = new char[size + 1];
    result[size] = '\0';
    memcpy(result, typeName, size);
    return result;
}


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QBluetoothServiceInfo_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SbkObject *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QBluetoothServiceInfo >()))
        return -1;

    ::QBluetoothServiceInfo *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.__init__";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QBluetoothServiceInfo", 0, 1, &(pyArgs[0])))
        return -1;


    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::QBluetoothServiceInfo()
    // 1: QBluetoothServiceInfo::QBluetoothServiceInfo(QBluetoothServiceInfo)
    if (numArgs == 0) {
        overloadId = 0; // QBluetoothServiceInfo()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], (pyArgs[0])))) {
        overloadId = 1; // QBluetoothServiceInfo(QBluetoothServiceInfo)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfo_Init_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // QBluetoothServiceInfo()
        {

            if (!PyErr_Occurred()) {
                // QBluetoothServiceInfo()
                cptr = new ::QBluetoothServiceInfo();
            }
            break;
        }
        case 1: // QBluetoothServiceInfo(const QBluetoothServiceInfo & other)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QBluetoothServiceInfo cppArg0_local;
            ::QBluetoothServiceInfo *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (!PyErr_Occurred()) {
                // QBluetoothServiceInfo(QBluetoothServiceInfo)
                cptr = new ::QBluetoothServiceInfo(*cppArg0);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QBluetoothServiceInfo >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QBluetoothServiceInfo_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QBluetoothServiceInfo_Init_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        return -1;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_attribute(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.attribute";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::attribute(quint16)const->QVariant
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArg)))) {
        overloadId = 0; // attribute(quint16)const
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfoFunc_attribute_TypeError;

    // Call function/method
    {
        quint16 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // attribute(quint16)const
            QVariant cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->attribute(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QVARIANT_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_QBluetoothServiceInfoFunc_attribute_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_attributes(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.attributes";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // attributes()const
            QList<quint16 > cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->attributes();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypeConverters[SBK_QTBLUETOOTH_QLIST_QUINT16_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_contains(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.contains";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::contains(quint16)const->bool
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArg)))) {
        overloadId = 0; // contains(quint16)const
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfoFunc_contains_TypeError;

    // Call function/method
    {
        quint16 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // contains(quint16)const
            bool cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->contains(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_QBluetoothServiceInfoFunc_contains_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_device(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.device";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // device()const
            QBluetoothDeviceInfo cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->device();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHDEVICEINFO_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_isComplete(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.isComplete";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // isComplete()const
            bool cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->isComplete();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_isRegistered(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.isRegistered";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // isRegistered()const
            bool cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->isRegistered();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_isValid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.isValid";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // isValid()const
            bool cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->isValid();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_protocolDescriptor(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.protocolDescriptor";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::protocolDescriptor(QBluetoothUuid::ProtocolUuid)const->QBluetoothServiceInfo::Sequence
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHUUID_PROTOCOLUUID_IDX]))->converter, (pyArg)))) {
        overloadId = 0; // protocolDescriptor(QBluetoothUuid::ProtocolUuid)const
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfoFunc_protocolDescriptor_TypeError;

    // Call function/method
    {
        ::QBluetoothUuid::ProtocolUuid cppArg0 = static_cast< ::QBluetoothUuid::ProtocolUuid>(0);
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // protocolDescriptor(QBluetoothUuid::ProtocolUuid)const
            QBluetoothServiceInfo::Sequence cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->protocolDescriptor(cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_SEQUENCE_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_QBluetoothServiceInfoFunc_protocolDescriptor_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_protocolServiceMultiplexer(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.protocolServiceMultiplexer";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // protocolServiceMultiplexer()const
            int cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->protocolServiceMultiplexer();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_registerService(PyObject *self, PyObject *args, PyObject *kwds)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.registerService";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0};

    // invalid argument lengths
    if (numArgs > 1) {
        static PyObject *const too_many = Shiboken::String::createStaticString(">");
        errInfo.reset(too_many);
        Py_INCREF(errInfo.object());
        goto Sbk_QBluetoothServiceInfoFunc_registerService_TypeError;
    }

    if (!PyArg_ParseTuple(args, "|O:registerService", &(pyArgs[0])))
        return {};


    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::registerService(QBluetoothAddress)->bool
    if (numArgs == 0) {
        overloadId = 0; // registerService(QBluetoothAddress)
    } else if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHADDRESS_IDX], (pyArgs[0])))) {
        overloadId = 0; // registerService(QBluetoothAddress)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfoFunc_registerService_TypeError;

    // Call function/method
    {
        if (kwds && PyDict_Size(kwds) > 0) {
            PyObject *value{};
            Shiboken::AutoDecRef kwds_dup(PyDict_Copy(kwds));
            static PyObject *const key_localAdapter = Shiboken::String::createStaticString("localAdapter");
            if (PyDict_Contains(kwds, key_localAdapter)) {
                value = PyDict_GetItem(kwds, key_localAdapter);
                if (value && pyArgs[0]) {
                    errInfo.reset(key_localAdapter);
                    Py_INCREF(errInfo.object());
                    goto Sbk_QBluetoothServiceInfoFunc_registerService_TypeError;
                }
                if (value) {
                    pyArgs[0] = value;
                    if (!(pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHADDRESS_IDX], (pyArgs[0]))))
                        goto Sbk_QBluetoothServiceInfoFunc_registerService_TypeError;
                }
                PyDict_DelItem(kwds_dup, key_localAdapter);
            }
            if (PyDict_Size(kwds_dup) > 0) {
                errInfo.reset(kwds_dup.release());
                goto Sbk_QBluetoothServiceInfoFunc_registerService_TypeError;
            }
        }
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return {};
        ::QBluetoothAddress cppArg0_local = QBluetoothAddress();
        ::QBluetoothAddress *cppArg0 = &cppArg0_local;
        if (pythonToCpp[0]) {
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);
            }

        if (!PyErr_Occurred()) {
            // registerService(QBluetoothAddress)
            bool cppResult = cppSelf->registerService(*cppArg0);
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;

    Sbk_QBluetoothServiceInfoFunc_registerService_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_removeAttribute(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.removeAttribute";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::removeAttribute(quint16)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArg)))) {
        overloadId = 0; // removeAttribute(quint16)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfoFunc_removeAttribute_TypeError;

    // Call function/method
    {
        quint16 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // removeAttribute(quint16)
            cppSelf->removeAttribute(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QBluetoothServiceInfoFunc_removeAttribute_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serverChannel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.serverChannel";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // serverChannel()const
            int cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serverChannel();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<int>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serviceAvailability(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceAvailability";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // serviceAvailability()const
            quint8 cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serviceAvailability();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<quint8>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serviceClassUuids(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceClassUuids";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // serviceClassUuids()const
            QList<QBluetoothUuid > cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serviceClassUuids();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypeConverters[SBK_QTBLUETOOTH_QLIST_QBLUETOOTHUUID_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serviceDescription(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceDescription";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // serviceDescription()const
            QString cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serviceDescription();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serviceName(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceName";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // serviceName()const
            QString cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serviceName();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serviceProvider(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceProvider";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // serviceProvider()const
            QString cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serviceProvider();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_serviceUuid(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceUuid";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // serviceUuid()const
            QBluetoothUuid cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->serviceUuid();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHUUID_IDX], &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setAttribute(PyObject *self, PyObject *args)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.setAttribute";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[2];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0, 0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "setAttribute", 2, 2, &(pyArgs[0]), &(pyArgs[1])))
        return {};


    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setAttribute(quint16,QBluetoothServiceInfo::Alternative)
    // 1: QBluetoothServiceInfo::setAttribute(quint16,QBluetoothServiceInfo::Sequence)
    // 2: QBluetoothServiceInfo::setAttribute(quint16,QBluetoothUuid)
    // 3: QBluetoothServiceInfo::setAttribute(quint16,QVariant)
    if (numArgs >= 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint16>(), (pyArgs[0])))) {
        if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHUUID_IDX], (pyArgs[1])))) {
            overloadId = 2; // setAttribute(quint16,QBluetoothUuid)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_SEQUENCE_IDX], (pyArgs[1])))) {
            overloadId = 1; // setAttribute(quint16,QBluetoothServiceInfo::Sequence)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ALTERNATIVE_IDX], (pyArgs[1])))) {
            overloadId = 0; // setAttribute(quint16,QBluetoothServiceInfo::Alternative)
        } else if (numArgs == 2
            && (pythonToCpp[1] = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QVARIANT_IDX], (pyArgs[1])))) {
            overloadId = 3; // setAttribute(quint16,QVariant)
        }
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfoFunc_setAttribute_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // setAttribute(quint16 attributeId, const QBluetoothServiceInfo::Alternative & value)
        {
            quint16 cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QBluetoothServiceInfo::Alternative cppArg1_local;
            ::QBluetoothServiceInfo::Alternative *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (!PyErr_Occurred()) {
                // setAttribute(quint16,QBluetoothServiceInfo::Alternative)
                cppSelf->setAttribute(cppArg0, *cppArg1);
            }
            break;
        }
        case 1: // setAttribute(quint16 attributeId, const QBluetoothServiceInfo::Sequence & value)
        {
            quint16 cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QBluetoothServiceInfo::Sequence cppArg1_local;
            ::QBluetoothServiceInfo::Sequence *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (!PyErr_Occurred()) {
                // setAttribute(quint16,QBluetoothServiceInfo::Sequence)
                cppSelf->setAttribute(cppArg0, *cppArg1);
            }
            break;
        }
        case 2: // setAttribute(quint16 attributeId, const QBluetoothUuid & value)
        {
            quint16 cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            if (!Shiboken::Object::isValid(pyArgs[1]))
                return {};
            ::QBluetoothUuid cppArg1_local;
            ::QBluetoothUuid *cppArg1 = &cppArg1_local;
            if (pythonToCpp[1].isValue())
                pythonToCpp[1](pyArgs[1], &cppArg1_local);
            else
                pythonToCpp[1](pyArgs[1], &cppArg1);


            if (!PyErr_Occurred()) {
                // setAttribute(quint16,QBluetoothUuid)
                cppSelf->setAttribute(cppArg0, *cppArg1);
            }
            break;
        }
        case 3: // setAttribute(quint16 attributeId, const QVariant & value)
        {
            quint16 cppArg0;
            pythonToCpp[0](pyArgs[0], &cppArg0);
            ::QVariant cppArg1;
            pythonToCpp[1](pyArgs[1], &cppArg1);

            if (!PyErr_Occurred()) {
                // setAttribute(quint16,QVariant)
                cppSelf->setAttribute(cppArg0, cppArg1);
            }
            break;
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QBluetoothServiceInfoFunc_setAttribute_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setDevice(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.setDevice";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setDevice(QBluetoothDeviceInfo)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHDEVICEINFO_IDX], (pyArg)))) {
        overloadId = 0; // setDevice(QBluetoothDeviceInfo)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfoFunc_setDevice_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QBluetoothDeviceInfo cppArg0_local;
        ::QBluetoothDeviceInfo *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (!PyErr_Occurred()) {
            // setDevice(QBluetoothDeviceInfo)
            cppSelf->setDevice(*cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QBluetoothServiceInfoFunc_setDevice_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setServiceAvailability(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceAvailability";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setServiceAvailability(quint8)
    if (SbkChar_Check(pyArg) && (pythonToCpp = Shiboken::Conversions::pythonToCppConversion(Shiboken::Conversions::PrimitiveTypeConverter<quint8>(), (pyArg)))) {
        overloadId = 0; // setServiceAvailability(quint8)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfoFunc_setServiceAvailability_TypeError;

    // Call function/method
    {
        quint8 cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setServiceAvailability(quint8)
            cppSelf->setServiceAvailability(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QBluetoothServiceInfoFunc_setServiceAvailability_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setServiceDescription(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceDescription";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setServiceDescription(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // setServiceDescription(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfoFunc_setServiceDescription_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setServiceDescription(QString)
            cppSelf->setServiceDescription(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QBluetoothServiceInfoFunc_setServiceDescription_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setServiceName(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceName";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setServiceName(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // setServiceName(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfoFunc_setServiceName_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setServiceName(QString)
            cppSelf->setServiceName(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QBluetoothServiceInfoFunc_setServiceName_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setServiceProvider(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceProvider";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setServiceProvider(QString)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppConversion(SbkPySide6_QtCoreTypeConverters[SBK_QSTRING_IDX], (pyArg)))) {
        overloadId = 0; // setServiceProvider(QString)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfoFunc_setServiceProvider_TypeError;

    // Call function/method
    {
        ::QString cppArg0;
        pythonToCpp(pyArg, &cppArg0);

        if (!PyErr_Occurred()) {
            // setServiceProvider(QString)
            cppSelf->setServiceProvider(cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QBluetoothServiceInfoFunc_setServiceProvider_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_setServiceUuid(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceUuid";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QBluetoothServiceInfo::setServiceUuid(QBluetoothUuid)
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHUUID_IDX], (pyArg)))) {
        overloadId = 0; // setServiceUuid(QBluetoothUuid)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QBluetoothServiceInfoFunc_setServiceUuid_TypeError;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QBluetoothUuid cppArg0_local;
        ::QBluetoothUuid *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (!PyErr_Occurred()) {
            // setServiceUuid(QBluetoothUuid)
            cppSelf->setServiceUuid(*cppArg0);
        }
    }

    if (PyErr_Occurred()) {
        return {};
    }
    Py_RETURN_NONE;

    Sbk_QBluetoothServiceInfoFunc_setServiceUuid_TypeError:
        Shiboken::setErrorAboutWrongArguments(pyArg, fullName, errInfo);
        return {};
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_socketProtocol(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.socketProtocol";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // socketProtocol()const
            QBluetoothServiceInfo::Protocol cppResult = const_cast<const ::QBluetoothServiceInfo *>(cppSelf)->socketProtocol();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_PROTOCOL_IDX]))->converter, &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfoFunc_unregisterService(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtBluetooth.QBluetoothServiceInfo.unregisterService";
    SBK_UNUSED(fullName)

    // Call function/method
    {

        if (!PyErr_Occurred()) {
            // unregisterService()
            bool cppResult = cppSelf->unregisterService();
            pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
        }
    }

    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QBluetoothServiceInfo___copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], &cppSelf);
    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QBluetoothServiceInfo_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QBluetoothServiceInfo_methods[] = {
    {"attribute", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_attribute), METH_O},
    {"attributes", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_attributes), METH_NOARGS},
    {"contains", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_contains), METH_O},
    {"device", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_device), METH_NOARGS},
    {"isComplete", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_isComplete), METH_NOARGS},
    {"isRegistered", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_isRegistered), METH_NOARGS},
    {"isValid", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_isValid), METH_NOARGS},
    {"protocolDescriptor", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_protocolDescriptor), METH_O},
    {"protocolServiceMultiplexer", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_protocolServiceMultiplexer), METH_NOARGS},
    {"registerService", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_registerService), METH_VARARGS|METH_KEYWORDS},
    {"removeAttribute", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_removeAttribute), METH_O},
    {"serverChannel", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serverChannel), METH_NOARGS},
    {"serviceAvailability", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serviceAvailability), METH_NOARGS},
    {"serviceClassUuids", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serviceClassUuids), METH_NOARGS},
    {"serviceDescription", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serviceDescription), METH_NOARGS},
    {"serviceName", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serviceName), METH_NOARGS},
    {"serviceProvider", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serviceProvider), METH_NOARGS},
    {"serviceUuid", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_serviceUuid), METH_NOARGS},
    {"setAttribute", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setAttribute), METH_VARARGS},
    {"setDevice", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setDevice), METH_O},
    {"setServiceAvailability", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setServiceAvailability), METH_O},
    {"setServiceDescription", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setServiceDescription), METH_O},
    {"setServiceName", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setServiceName), METH_O},
    {"setServiceProvider", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setServiceProvider), METH_O},
    {"setServiceUuid", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_setServiceUuid), METH_O},
    {"socketProtocol", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_socketProtocol), METH_NOARGS},
    {"unregisterService", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfoFunc_unregisterService), METH_NOARGS},

    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QBluetoothServiceInfo___copy__), METH_NOARGS},
    {nullptr, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QBluetoothServiceInfo_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_QBluetoothServiceInfo_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
extern "C"
{
static PyObject *Sbk_QBluetoothServiceInfo__repr__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto cppSelf = reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    QBuffer buffer;
    buffer.open(QBuffer::ReadWrite);
    QDebug dbg(&buffer);
    dbg << *cppSelf;
    buffer.close();
    QByteArray str = buffer.data();
    int idx = str.indexOf('(');
    if (idx >= 0)
        str.replace(0, idx, Py_TYPE(self)->tp_name);
    str = str.trimmed();
    PyObject *mod = PyDict_GetItem(Py_TYPE(self)->tp_dict, Shiboken::PyMagicName::module());
    if (mod && !strchr(str, '.'))
        return Shiboken::String::fromFormat("<%s.%s at %p>", Shiboken::String::toCString(mod), str.constData(), self);
    else
        return Shiboken::String::fromFormat("<%s at %p>", str.constData(), self);
}
} // extern C

// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QBluetoothServiceInfo_Type = nullptr;
static PyTypeObject *Sbk_QBluetoothServiceInfo_TypeF(void)
{
    return _Sbk_QBluetoothServiceInfo_Type;
}

static PyType_Slot Sbk_QBluetoothServiceInfo_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        reinterpret_cast<void *>(Sbk_QBluetoothServiceInfo__repr__)},
    {Py_tp_hash,        nullptr},
    {Py_tp_call,        nullptr},
    {Py_tp_str,         nullptr},
    {Py_tp_getattro,    nullptr},
    {Py_tp_setattro,    nullptr},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QBluetoothServiceInfo_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QBluetoothServiceInfo_clear)},
    {Py_tp_richcompare, nullptr},
    {Py_tp_iter,        nullptr},
    {Py_tp_iternext,    nullptr},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QBluetoothServiceInfo_methods)},
    {Py_tp_getset,      nullptr},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QBluetoothServiceInfo_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObjectTpNew)},
    {0, nullptr}
};
static PyType_Spec Sbk_QBluetoothServiceInfo_spec = {
    "2:PySide6.QtBluetooth.QBluetoothServiceInfo",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QBluetoothServiceInfo_slots
};

} //extern "C"


// Type conversion functions.

// Python to C++ enum conversion.
static void QBluetoothServiceInfo_AttributeId_PythonToCpp_QBluetoothServiceInfo_AttributeId(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QBluetoothServiceInfo::AttributeId *>(cppOut) =
        static_cast<::QBluetoothServiceInfo::AttributeId>(Shiboken::Enum::getValue(pyIn));

}
static PythonToCppFunc is_QBluetoothServiceInfo_AttributeId_PythonToCpp_QBluetoothServiceInfo_AttributeId_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX]))
        return QBluetoothServiceInfo_AttributeId_PythonToCpp_QBluetoothServiceInfo_AttributeId;
    return {};
}
static PyObject *QBluetoothServiceInfo_AttributeId_CppToPython_QBluetoothServiceInfo_AttributeId(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QBluetoothServiceInfo::AttributeId *>(cppIn));
    return Shiboken::Enum::newItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX], castCppIn);

}

static void QBluetoothServiceInfo_Protocol_PythonToCpp_QBluetoothServiceInfo_Protocol(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QBluetoothServiceInfo::Protocol *>(cppOut) =
        static_cast<::QBluetoothServiceInfo::Protocol>(Shiboken::Enum::getValue(pyIn));

}
static PythonToCppFunc is_QBluetoothServiceInfo_Protocol_PythonToCpp_QBluetoothServiceInfo_Protocol_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_PROTOCOL_IDX]))
        return QBluetoothServiceInfo_Protocol_PythonToCpp_QBluetoothServiceInfo_Protocol;
    return {};
}
static PyObject *QBluetoothServiceInfo_Protocol_CppToPython_QBluetoothServiceInfo_Protocol(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QBluetoothServiceInfo::Protocol *>(cppIn));
    return Shiboken::Enum::newItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_PROTOCOL_IDX], castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QBluetoothServiceInfo_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_QBluetoothServiceInfo_TypeF())))
        return QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QBluetoothServiceInfo_PTR_CppToPython_QBluetoothServiceInfo(const void *cppIn)
{
    auto pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto tCppIn = reinterpret_cast<const ::QBluetoothServiceInfo *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = typeNameOf(tCppIn);
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QBluetoothServiceInfo_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QBluetoothServiceInfo_COPY_CppToPython_QBluetoothServiceInfo(const void *cppIn)
{
    return Shiboken::Object::newObject(Sbk_QBluetoothServiceInfo_TypeF(), new ::QBluetoothServiceInfo(*reinterpret_cast<const ::QBluetoothServiceInfo *>(cppIn)), true, true);
}

// Python to C++ copy conversion.
static void QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QBluetoothServiceInfo *>(cppOut) = *reinterpret_cast< ::QBluetoothServiceInfo *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX], reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_QBluetoothServiceInfo_TypeF())))
        return QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QBluetoothServiceInfo_SignatureStrings[] = {
    "1:PySide6.QtBluetooth.QBluetoothServiceInfo(self)",
    "0:PySide6.QtBluetooth.QBluetoothServiceInfo(self,other:PySide6.QtBluetooth.QBluetoothServiceInfo)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.attribute(self,attributeId:quint16)->QVariant",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.attributes(self)->QList[quint16]",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.contains(self,attributeId:quint16)->bool",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.device(self)->PySide6.QtBluetooth.QBluetoothDeviceInfo",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.isComplete(self)->bool",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.isRegistered(self)->bool",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.isValid(self)->bool",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.protocolDescriptor(self,protocol:PySide6.QtBluetooth.QBluetoothUuid.ProtocolUuid)->PySide6.QtBluetooth.QBluetoothServiceInfo.Sequence",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.protocolServiceMultiplexer(self)->int",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.registerService(self,localAdapter:PySide6.QtBluetooth.QBluetoothAddress=QBluetoothAddress())->bool",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.removeAttribute(self,attributeId:quint16)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serverChannel(self)->int",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceAvailability(self)->quint8",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceClassUuids(self)->QList[PySide6.QtBluetooth.QBluetoothUuid]",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceDescription(self)->QString",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceName(self)->QString",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceProvider(self)->QString",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.serviceUuid(self)->PySide6.QtBluetooth.QBluetoothUuid",
    "3:PySide6.QtBluetooth.QBluetoothServiceInfo.setAttribute(self,attributeId:quint16,value:typing.Union[PySide6.QtBluetooth.QBluetoothServiceInfo.Alternative, QList[QVariant]])",
    "2:PySide6.QtBluetooth.QBluetoothServiceInfo.setAttribute(self,attributeId:quint16,value:typing.Union[PySide6.QtBluetooth.QBluetoothServiceInfo.Sequence, QList[QVariant]])",
    "1:PySide6.QtBluetooth.QBluetoothServiceInfo.setAttribute(self,attributeId:quint16,value:typing.Union[PySide6.QtBluetooth.QBluetoothUuid, PySide6.QtBluetooth.QBluetoothUuid.CharacteristicType, PySide6.QtBluetooth.QBluetoothUuid.DescriptorType, PySide6.QtBluetooth.QBluetoothUuid.ProtocolUuid, PySide6.QtBluetooth.QBluetoothUuid.ServiceClassUuid, PySide6.QtCore.QUuid])",
    "0:PySide6.QtBluetooth.QBluetoothServiceInfo.setAttribute(self,attributeId:quint16,value:QVariant)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.setDevice(self,info:PySide6.QtBluetooth.QBluetoothDeviceInfo)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceAvailability(self,availability:quint8)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceDescription(self,description:QString)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceName(self,name:QString)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceProvider(self,provider:QString)",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.setServiceUuid(self,uuid:typing.Union[PySide6.QtBluetooth.QBluetoothUuid, PySide6.QtBluetooth.QBluetoothUuid.CharacteristicType, PySide6.QtBluetooth.QBluetoothUuid.DescriptorType, PySide6.QtBluetooth.QBluetoothUuid.ProtocolUuid, PySide6.QtBluetooth.QBluetoothUuid.ServiceClassUuid, PySide6.QtCore.QUuid])",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.socketProtocol(self)->PySide6.QtBluetooth.QBluetoothServiceInfo.Protocol",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.unregisterService(self)->bool",
    "PySide6.QtBluetooth.QBluetoothServiceInfo.__copy__()",
    nullptr}; // Sentinel

void init_QBluetoothServiceInfo(PyObject *module)
{
    _Sbk_QBluetoothServiceInfo_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QBluetoothServiceInfo",
        "QBluetoothServiceInfo",
        &Sbk_QBluetoothServiceInfo_spec,
        &Shiboken::callCppDestructor< ::QBluetoothServiceInfo >,
        0,
        0,
        0);
    auto *pyType = Sbk_QBluetoothServiceInfo_TypeF(); // references _Sbk_QBluetoothServiceInfo_Type
    InitSignatureStrings(pyType, QBluetoothServiceInfo_SignatureStrings);
    SbkObjectType_SetPropertyStrings(reinterpret_cast<PyTypeObject *>(_Sbk_QBluetoothServiceInfo_Type), Sbk_QBluetoothServiceInfo_PropertyStrings);
    SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_IDX]
        = Sbk_QBluetoothServiceInfo_TypeF();

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(Sbk_QBluetoothServiceInfo_TypeF(),
        QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_PTR,
        is_QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_PTR_Convertible,
        QBluetoothServiceInfo_PTR_CppToPython_QBluetoothServiceInfo,
        QBluetoothServiceInfo_COPY_CppToPython_QBluetoothServiceInfo);

    Shiboken::Conversions::registerConverterName(converter, "QBluetoothServiceInfo");
    Shiboken::Conversions::registerConverterName(converter, "QBluetoothServiceInfo*");
    Shiboken::Conversions::registerConverterName(converter, "QBluetoothServiceInfo&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QBluetoothServiceInfo).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_COPY,
        is_QBluetoothServiceInfo_PythonToCpp_QBluetoothServiceInfo_COPY_Convertible);

    // Initialization of enums.

    // Initialization of enum 'AttributeId'.
    SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX] = Shiboken::Enum::createScopedEnum(Sbk_QBluetoothServiceInfo_TypeF(),
        "AttributeId",
        "2:PySide6.QtBluetooth.QBluetoothServiceInfo.AttributeId",
        "QBluetoothServiceInfo::AttributeId");
    if (!SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX])
        return;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "ServiceRecordHandle", (long) QBluetoothServiceInfo::AttributeId::ServiceRecordHandle))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "ServiceClassIds", (long) QBluetoothServiceInfo::AttributeId::ServiceClassIds))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "ServiceRecordState", (long) QBluetoothServiceInfo::AttributeId::ServiceRecordState))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "ServiceId", (long) QBluetoothServiceInfo::AttributeId::ServiceId))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "ProtocolDescriptorList", (long) QBluetoothServiceInfo::AttributeId::ProtocolDescriptorList))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "BrowseGroupList", (long) QBluetoothServiceInfo::AttributeId::BrowseGroupList))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "LanguageBaseAttributeIdList", (long) QBluetoothServiceInfo::AttributeId::LanguageBaseAttributeIdList))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "ServiceInfoTimeToLive", (long) QBluetoothServiceInfo::AttributeId::ServiceInfoTimeToLive))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "ServiceAvailability", (long) QBluetoothServiceInfo::AttributeId::ServiceAvailability))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "BluetoothProfileDescriptorList", (long) QBluetoothServiceInfo::AttributeId::BluetoothProfileDescriptorList))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "DocumentationUrl", (long) QBluetoothServiceInfo::AttributeId::DocumentationUrl))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "ClientExecutableUrl", (long) QBluetoothServiceInfo::AttributeId::ClientExecutableUrl))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "IconUrl", (long) QBluetoothServiceInfo::AttributeId::IconUrl))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "AdditionalProtocolDescriptorList", (long) QBluetoothServiceInfo::AttributeId::AdditionalProtocolDescriptorList))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "PrimaryLanguageBase", (long) QBluetoothServiceInfo::AttributeId::PrimaryLanguageBase))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "ServiceName", (long) QBluetoothServiceInfo::AttributeId::ServiceName))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "ServiceDescription", (long) QBluetoothServiceInfo::AttributeId::ServiceDescription))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "ServiceProvider", (long) QBluetoothServiceInfo::AttributeId::ServiceProvider))
        return;
    // Register converter for enum 'QBluetoothServiceInfo::AttributeId'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX],
            QBluetoothServiceInfo_AttributeId_CppToPython_QBluetoothServiceInfo_AttributeId);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QBluetoothServiceInfo_AttributeId_PythonToCpp_QBluetoothServiceInfo_AttributeId,
            is_QBluetoothServiceInfo_AttributeId_PythonToCpp_QBluetoothServiceInfo_AttributeId_Convertible);
        Shiboken::Enum::setTypeConverter(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_ATTRIBUTEID_IDX], converter, false);
        Shiboken::Conversions::registerConverterName(converter, "QBluetoothServiceInfo::AttributeId");
        Shiboken::Conversions::registerConverterName(converter, "AttributeId");
    }
    // End of 'AttributeId' enum.

    // Initialization of enum 'Protocol'.
    SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_PROTOCOL_IDX] = Shiboken::Enum::createScopedEnum(Sbk_QBluetoothServiceInfo_TypeF(),
        "Protocol",
        "2:PySide6.QtBluetooth.QBluetoothServiceInfo.Protocol",
        "QBluetoothServiceInfo::Protocol");
    if (!SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_PROTOCOL_IDX])
        return;

    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_PROTOCOL_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "UnknownProtocol", (long) QBluetoothServiceInfo::Protocol::UnknownProtocol))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_PROTOCOL_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "L2capProtocol", (long) QBluetoothServiceInfo::Protocol::L2capProtocol))
        return;
    if (!Shiboken::Enum::createScopedEnumItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_PROTOCOL_IDX],
        Sbk_QBluetoothServiceInfo_TypeF(), "RfcommProtocol", (long) QBluetoothServiceInfo::Protocol::RfcommProtocol))
        return;
    // Register converter for enum 'QBluetoothServiceInfo::Protocol'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_PROTOCOL_IDX],
            QBluetoothServiceInfo_Protocol_CppToPython_QBluetoothServiceInfo_Protocol);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QBluetoothServiceInfo_Protocol_PythonToCpp_QBluetoothServiceInfo_Protocol,
            is_QBluetoothServiceInfo_Protocol_PythonToCpp_QBluetoothServiceInfo_Protocol_Convertible);
        Shiboken::Enum::setTypeConverter(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTHSERVICEINFO_PROTOCOL_IDX], converter, false);
        Shiboken::Conversions::registerConverterName(converter, "QBluetoothServiceInfo::Protocol");
        Shiboken::Conversions::registerConverterName(converter, "Protocol");
    }
    // End of 'Protocol' enum.

    qRegisterMetaType< ::QBluetoothServiceInfo >("QBluetoothServiceInfo");
    qRegisterMetaType< ::QBluetoothServiceInfo::AttributeId >("QBluetoothServiceInfo::AttributeId");
    qRegisterMetaType< ::QBluetoothServiceInfo::Protocol >("QBluetoothServiceInfo::Protocol");
}
